// TrfmDlg.cpp : implementation file
//

#include "stdafx.h"
#include "3dPlus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransformDlg

IMPLEMENT_DYNAMIC(CTransformDlg, CPropertySheet)

CTransformDlg::CTransformDlg(LPCTSTR pszCaption, 
							  ONCLOSEDLGFN pOnCloseFn,
							  GET3DFRAMEFN pGet3dFrameFn,
							  void *pArg)
:CPropertySheet(pszCaption, NULL, 0)
{
	m_pOnCloseFn = pOnCloseFn;
	m_pGet3dFrameFn = pGet3dFrameFn;
	m_pArg = pArg;
	ASSERT(m_pOnCloseFn);
	ASSERT(m_pGet3dFrameFn);

	m_TranPage.m_pTranDlg = this;
	m_RotPage.m_pTranDlg = this;
	m_ScalePage.m_pTranDlg = this;

	// Add the pages
	AddPage(&m_TranPage);
	AddPage(&m_RotPage);
	AddPage(&m_ScalePage);

	// Create
	Create();
}

CTransformDlg::~CTransformDlg()
{
	ASSERT(m_pOnCloseFn);
	m_pOnCloseFn(m_pArg);
}


BEGIN_MESSAGE_MAP(CTransformDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CTransformDlg)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransformDlg message handlers


void CTransformDlg::OnClose() 
{
	DestroyWindow();
}

void CTransformDlg::PostNcDestroy() 
{
	delete this;
}
