// CClrPage.cpp : implementation file
//

#include "stdafx.h"
#include "..\Include\3dPlus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClrPage property page

IMPLEMENT_DYNCREATE(CClrPage, CClrBasePage)

CClrPage::CClrPage() : CClrBasePage(CClrPage::IDD)
{
	//{{AFX_DATA_INIT(CClrPage)
	m_iFace = 0;
	//}}AFX_DATA_INIT
	m_dRed = 0.5;
	m_dGreen = 0.5;
	m_dBlue = 0.5;
}

CClrPage::~CClrPage()
{
}

void CClrPage::DoDataExchange(CDataExchange* pDX)
{
	CClrBasePage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClrPage)
	DDX_Control(pDX, _3D_IDC_FACECOUNT, m_wndFaceCount);
	DDX_Control(pDX, _3D_IDC_RED, m_sbRed);
	DDX_Control(pDX, _3D_IDC_GREEN, m_sbGreen);
	DDX_Control(pDX, _3D_IDC_BLUE, m_sbBlue);
	DDX_Text(pDX, _3D_IDC_FACE, m_iFace);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClrPage, CClrBasePage)
	//{{AFX_MSG_MAP(CClrPage)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClrPage message handlers

BOOL CClrPage::OnSetActive() 
{
	m_sbRed.SetScrollRange(0, 255);
	m_sbGreen.SetScrollRange(0, 255);
	m_sbBlue.SetScrollRange(0, 255);

	m_sbRed.SetScrollPos((int)(m_dRed * 255));
	m_sbGreen.SetScrollPos((int)(m_dGreen * 255));
	m_sbBlue.SetScrollPos((int)(m_dBlue * 255));

	ASSERT(m_pDlg);
	C3dShape* pShape = m_pDlg->GetShape();
	if (pShape) {
		int iFaces = pShape->GetFaceCount();
		char buf[64];
		sprintf(buf, "0 - %d", iFaces - 1);
		m_wndFaceCount.SetWindowText(buf);
	}
	CheckRadioButton(_3D_IDC_RADIO1, _3D_IDC_RADIO2, _3D_IDC_RADIO1);

	return TRUE;
}

void CClrPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// update the position
	int iPos = pScrollBar->GetScrollPos();
	switch(nSBCode) {
	case SB_LINELEFT:
		iPos -= 4;
		break;
	case SB_PAGELEFT:
		iPos -= 32;
		break;
	case SB_LINERIGHT:
		iPos += 4;
		break;
	case SB_PAGERIGHT:
		iPos += 32;
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		iPos = nPos;
		break;
	default:
		return;
	}
	if (iPos < 0) {
		iPos = 0;
	} else if (iPos > 255) {
		iPos = 255;
	}
	pScrollBar->SetScrollPos(iPos);

	// now grab the current positions, set the values
	// and update the shape color
	m_dRed = m_sbRed.GetScrollPos() / 255.0;
	m_dGreen = m_sbGreen.GetScrollPos() / 255.0;
	m_dBlue = m_sbBlue.GetScrollPos() / 255.0;

	ASSERT(m_pDlg);
	C3dShape* pShape = m_pDlg->GetShape();
	if (pShape) {
		if (IsDlgButtonChecked(_3D_IDC_RADIO1)) {
			pShape->SetColor(m_dRed, m_dGreen, m_dBlue);
		} else {
			// set a single face color
			UpdateData(TRUE);
			pShape->SetFaceColor(m_iFace, m_dRed, m_dGreen, m_dBlue);
		}
	}

}

