// colordlg.cpp : implementation file
//

#include "stdafx.h"
#include "..\Include\3dPlus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClrBasePage

IMPLEMENT_DYNAMIC(CClrBasePage, CPropertyPage)

CClrBasePage::CClrBasePage(UINT id)
: CPropertyPage(id)
{
	m_pDlg = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CColorDlg

IMPLEMENT_DYNAMIC(CColorDlg, CPropertySheet)

CColorDlg::CColorDlg(LPCTSTR pszCaption, 
					  ONCLOSEDLGFN pOnCloseFn,
					  GET3DSHAPEFN pGet3dShapeFn,
					  void *pArg,
					  C3dImageList* pImgList)
:CPropertySheet(pszCaption, NULL, 0)
{
	m_pOnCloseFn = pOnCloseFn;
	m_pGet3dShapeFn = pGet3dShapeFn;
	m_pArg = pArg;
	ASSERT(m_pOnCloseFn);
	ASSERT(m_pGet3dShapeFn);

	m_ClrPage.m_pDlg = this;
	m_MatPage.m_pDlg = this;
	m_TexPage.m_pDlg = this;
	m_TexPage.m_pImgList = pImgList;

	AddPage(&m_ClrPage);
	AddPage(&m_MatPage);
	AddPage(&m_TexPage);

	Create();
}

CColorDlg::~CColorDlg()
{
	ASSERT(m_pOnCloseFn);
	m_pOnCloseFn(m_pArg);
}


BEGIN_MESSAGE_MAP(CColorDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CColorDlg)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorDlg message handlers


void CColorDlg::OnClose() 
{
	DestroyWindow();
}

void CColorDlg::PostNcDestroy() 
{
	delete this;
}
